class User
  def can_create_user?(new_user)
    if EConfiguration.first.user_requires_expiration_date?
      if new_user.active? && new_user.expiration_date.nil? && !admin?
        return false
      end
    end
    true
  end

  def can_destroy_user?(other_user)
    return false if MultiServer::Synchronizer.slave_server?
    return false if other_user == self
    return false if other_user.pending?
    return false if other_user.super_admin? && !self.super_admin?
    true
  end

  def can_edit_user?(other_user)
    !other_user.pending? &&
      MultiServer::Synchronizer.master_server? &&
      (super_admin? || (admin? && !other_user.super_admin?))
  end

  def can_set_account_active?(other_user)
    case
    when other_user == self
      false
    when other_user.is_a?(DirectoryServiceUser) && !other_user.saml? && RbConfig.ds_sync_active_state?
      false
    else
      true
    end
  end

  def can_send_to_external_email?
    value = case can_send_to_external_email
    when User::Permissionable::YES     then true
    when User::Permissionable::DEFAULT then EConfiguration.allow_send_to_email_default?
    else
      false
    end

    value && EConfiguration.allow_send_to_email?
  end

  def can_send_to_all_faspex_users?
    case can_send_to_all_faspex_users
    when User::Permissionable::YES
      true
    when User::Permissionable::NO
      false
    else
      EConfiguration.first.users_can_send_to_all_faspex_users
    end
  end


    def can_send_normal_packages?
      case can_send_normal_packages
        when User::Permissionable::YES
          true
        when User::Permissionable::NO
          false
        else
          EConfiguration.first.users_can_send_normal_packages
      end
    end

end
