function app_id() {
  var current_user_app_id = document.getElementById('current_user_connect_app_id');
  if (!!current_user_app_id) {
    return current_user_app_id.getAttribute('data-app-id');
  }
}

function is_user_external(){
  var current_user_external = document.getElementById('current_user_external');
  if (!!current_user_external) {
    return current_user_external.getAttribute('data-is-user-external');
  }
}

(function(window) {
  'use strict';

  var $j = window.jQuery;

  var AW4_URL = '//d3gcli72yxqn2z.cloudfront.net/connect/v4';
  var use_local = false;
  window.faspexPlugin = {
    useLocalConnect: function() {
        use_local = true;
        AW4_URL = '//'+window.location.host + aspera_faspex_uri_namespace + '/connect/v4';
    },
    handleUpdate: function() {
      if (window.httpTransferDisabled()) {
        window.handleNoTransferWithUpgrade();
      }
      else {
        window.handleHttpTransfer();
      }
    },

    handleConnectReady: function() {
      /* Called if Aspera Connect is installed and meets version requirements. */
      window.handleConnectTransfer();
    },

    handleInstall: function() {
      window[
        window.httpTransferDisabled() ? 'handleNoTransfer' : 'handleHttpTransfer'
      ]();
    },

    initAsperaConnect: function() {
      var that = this;
      window.faspexAW = new $j.Deferred();

      var globalSettings = $j(document.body).data('global-settings');
      var minConnectVersion = globalSettings &&
        globalSettings.minimum_connect_version;
      var prefer_http_connect = globalSettings && globalSettings.prefer_http_connect;
       var parseConnectDownloadLink = function(referencesJSON) {
        var i=0,l=referencesJSON.links.length,link;
        for ( ; i < l; i++ ) {
          link = referencesJSON.links[i];
          if ( link.rel === 'enclosure' ) {
            window.connect_download_link = AW4_URL + '/' +  link.href;
          }
        }
      };

      var loadJS = function (file, onload) {
        return $j.ajax({
          url: file,
          dataType: 'script',
          crossDomain: true,
          success: onload,
          error: function() {
            if (!use_local) {
              window.faspexPlugin.useLocalConnect();
              attemptLoadJS();
            }
          }
        });
      };

      // Hackish - Goal is to detect closure of connect banner,
      // which we can't mess with because it's in an IFrame
      // First, detect that the IFrame is present by polling
      function detectConnectIFrame(){
        if(window.connectInstalled){ return; }

        var iframe = document.getElementById('aspera-iframe-container');

        if(!iframe || iframe.style.display == "none" || iframe.style.visibility == "hidden"){
          setTimeout(detectConnectIFrame, 500);
          return;
        }

        detectConnectIFrameRemoved();
      }

      // Then, detect when it has been removed, again by polling
      function detectConnectIFrameRemoved(){
        if(window.connectInstalled){ return; }

        var iframe = document.getElementById('aspera-iframe-container');

        if(iframe && iframe.style.display != "none" && iframe.style.visibility != "hidden"){
          setTimeout(detectConnectIFrameRemoved, 500);
          return;
        }

        if(confirm("Are you sure you want to forgo using IBM Aspera Connect?")){
          window.connect_disabled = true;
          var path = aspera_faspex_uri_namespace + '/disable_connect'
          if(window.location.search){
            path = path + window.location.search
          }

          jQuery.ajax({
            type: 'POST',
            url: path,
            dataType: 'json',
            success: function(data) {
              alert(
                data['messages'].join("\n\n")
              );

              location.reload();
            },
            error: function(e){}
          });
        } else{
          // User has clicked "Cancel", but connect window was already closed.
          // Reload page to restart connect initialization
          location.reload();
        }
      }

      var attemptLoadJS = function() {
          loadJS(AW4_URL + '/asperaweb-4.min.js',  function() {
              loadJS(AW4_URL + '/connectinstaller-4.min.js', function() {
                  var AW4 = window.AW4;

                  if (prefer_http_connect && AW4.Utils.BROWSER.CHROME) {
                      window.connect = new AW4.Connect({
                          sdkLocation: window.location.protocol + AW4_URL,
                          minVersion: minConnectVersion,
                          dragDropEnabled: true,
                          connectMethod: "http"
                      });
                      window.connectInstaller = new AW4.ConnectInstaller({
                          sdkLocation: window.location.protocol + AW4_URL,
                          style: "blue"
                      });
                  } else {
                      window.connect = new AW4.Connect({
                          sdkLocation: window.location.protocol + AW4_URL,
                          minVersion: minConnectVersion,
                          dragDropEnabled: true
                      });
                      window.connectInstaller = new AW4.ConnectInstaller({
                          sdkLocation: window.location.protocol + AW4_URL
                      });
                  }
                  window.connectOutdated = false;
                  window.connectInstaller.installationJSON(parseConnectDownloadLink);

                  var statusEventListener = function (eventType, data) {
                      if(window.connect_disabled){ return; }

                      if (eventType === AW4.Connect.EVENT.STATUS && data === AW4.Connect.STATUS.INITIALIZING) {
                          window.connectInstalled = false;
                          connectInstaller.showLaunching();
                          if(window.http_gateway_installed)
                              detectConnectIFrame();
                      } else if (eventType === AW4.Connect.EVENT.STATUS && data === AW4.Connect.STATUS.FAILED) {
                          setTimeout(function(){
                              if (!window.connectInstalled && !window.connectOutdated) {
                                  window.connectInstalled = false;
                                  that.handleInstall();
                                  if(!window.connect_disabled) {
                                    window.connectInstaller.showDownload();
                                  }
                              }
                          }, 15000);
                      } else if (eventType === AW4.Connect.EVENT.STATUS && data === AW4.Connect.STATUS.OUTDATED) {
                          window.connectOutdated = true;
                          that.handleUpdate();
                          window.connectInstaller.showUpdate();
                      } else if (eventType === AW4.Connect.EVENT.STATUS && data === AW4.Connect.STATUS.RUNNING) {
                          window.connectInstalled = true;
                          window.connectInstaller.connected();
                          window.faspexAW.resolve();
                          that.handleConnectReady();
                      }
                  };
                  if (window.connect) {
                    window.connect.addEventListener(
                      AW4.Connect.EVENT.STATUS, statusEventListener
                    );

                    if (app_id()) {
                      window.connect.initSession(app_id());
                    }
                  }
                  else {
                      window.faspexAW.reject();
                  }
              });
          });
      };
      attemptLoadJS();
    }
  };
})(window);
